#version 150

in vec3 Position;
in vec2 UV0;
in vec4 Color;

uniform mat4 ModelViewMat;
uniform mat4 ProjMat;
uniform vec2 ScreenSize;

out vec2 texCoord0;
out vec4 vertexColor;
out float isSlot;

void main() {
    gl_Position = ProjMat * ModelViewMat * vec4(Position, 1.0);
    vertexColor = Color;

    // Move bossbar
    float guiScale = (round(ScreenSize.x * ProjMat[0][0] / 2));
    if (Position.z == 1000) {
        if (gl_Position.y > 1.0 - 50/ScreenSize.y*guiScale) {
            float screenPos = -1.0 + 30/ScreenSize.y*guiScale;
            float newPos = -1.0 + 60/ScreenSize.y*guiScale;
            gl_Position.y += screenPos;
            gl_Position.y *= 1.4;
            gl_Position.y += newPos;
        } else if (gl_Position.y > 1.0 - 100/ScreenSize.y*guiScale) {
                float screenPos = -1.0 + 68/ScreenSize.y*guiScale;
                float newPos = -1.0 + 60/ScreenSize.y*guiScale;
                gl_Position.y += screenPos;
                gl_Position.y *= 1.4;
                gl_Position.y += newPos;
                gl_Position.z += 1;
        } else {
            gl_Position = ProjMat * ModelViewMat * (vec4(Position, 1.0) - vec4(0,33,0,0));
        }
    }
    // Mark correct slots for fragment
    if (abs(gl_Position.y+70/ScreenSize.y*guiScale) < 70/ScreenSize.y*guiScale && abs(gl_Position.x) < 160/ScreenSize.x*guiScale && Position.z == 0) { // && abs(Position.x-299) < 70
        isSlot = 1.0;
    } else {
        isSlot = 0.0;
    }

    texCoord0 = UV0;
}